Name:           yggdrasil
Version:        0.4.2
Release:        1%{?dist}.26
Summary:        End-to-end encrypted IPv6 networking

License:        GPLv3
URL:            https://yggdrasil-network.github.io
Source0:        https://github.com/yggdrasil-network/yggdrasil-go/archive/v%{version}/yggdrasil-go-%{version}.tar.gz
Source1:        update-sources.sh
#GO_BUNDLED_SRCS_BEGIN
Source100: https://github.com/Arceliar/ironwood/archive/6ad55cae5031/ironwood-6ad55cae5031.tar.gz
Source101: https://github.com/Arceliar/phony/archive/dde1a8dca979/phony-dde1a8dca979.tar.gz
Source102: https://github.com/VividCortex/ewma/archive/v1.2.0/ewma-1.2.0.tar.gz
Source103: https://github.com/cheggaaa/pb/archive/v3.0.8/pb-3.0.8.tar.gz
Source104: https://github.com/fatih/color/archive/v1.12.0/color-1.12.0.tar.gz
Source105: https://github.com/gologme/log/archive/v1.2.0/log-1.2.0.tar.gz
Source106: https://github.com/hashicorp/go-syslog/archive/v1.0.0/go-syslog-1.0.0.tar.gz
Source107: https://github.com/hjson/hjson-go/archive/v3.1.0/hjson-go-3.1.0.tar.gz
Source108: https://github.com/kardianos/minwinsvc/archive/v1.0.0/minwinsvc-1.0.0.tar.gz
Source109: https://github.com/lxn/walk/archive/c389da54e794/walk-c389da54e794.tar.gz
Source110: https://github.com/lxn/win/archive/a377121e959e/win-a377121e959e.tar.gz
Source111: https://github.com/mattn/go-colorable/archive/v0.1.8/go-colorable-0.1.8.tar.gz
Source112: https://github.com/mattn/go-isatty/archive/v0.0.13/go-isatty-0.0.13.tar.gz
Source113: https://github.com/mattn/go-runewidth/archive/v0.0.13/go-runewidth-0.0.13.tar.gz
Source114: https://github.com/mitchellh/mapstructure/archive/v1.4.1/mapstructure-1.4.1.tar.gz
Source115: https://github.com/rivo/uniseg/archive/v0.2.0/uniseg-0.2.0.tar.gz
Source116: https://github.com/vishvananda/netlink/archive/v1.1.0/netlink-1.1.0.tar.gz
Source117: https://github.com/vishvananda/netns/archive/2eb08e3e575f/netns-2eb08e3e575f.tar.gz
Source118: https://github.com/golang/crypto/archive/c07d793c2f9a/crypto-c07d793c2f9a.tar.gz
Source119: https://github.com/golang/net/archive/84b48f89b13b/net-84b48f89b13b.tar.gz
Source120: https://github.com/golang/sys/archive/a4fc73990273/sys-a4fc73990273.tar.gz
Source121: https://github.com/golang/term/archive/7de9c90e9dd1/term-7de9c90e9dd1.tar.gz
Source122: https://github.com/golang/text/archive/5c7c50ebbd4f/text-5c7c50ebbd4f.tar.gz
Source123: https://github.com/golang/tools/archive/90fa682c2a6e/tools-90fa682c2a6e.tar.gz
Source124: https://git.zx2c4.com/wireguard-go/snapshot/wireguard-go-f9b48a961cd2.tar.xz
Source125: https://git.zx2c4.com/wireguard-windows/snapshot/wireguard-windows-0.3.14.tar.xz
#GO_BUNDLED_SRCS_END

%{?systemd_requires}
BuildRequires:  systemd golang >= 1.13 git
Requires(pre):  shadow-utils
Conflicts:      yggdrasil-develop

%description
Yggdrasil is a proof-of-concept to explore a wholly different approach to
network routing. Whereas current computer networks depend heavily on very
centralised design and configuration, Yggdrasil breaks this mould by making
use of a global spanning tree to form a scalable IPv6 encrypted mesh network.

%define debug_package %{nil}

%pre
getent group yggdrasil >/dev/null || groupadd -r yggdrasil
exit 0

%prep
%setup -qn yggdrasil-go-%{version}
#GO_BUNDLED_PREP_BEGIN
# github.com/Arceliar/ironwood v0.0.0-20210619124114-6ad55cae5031
%{__mkdir_p} 'vendor/github.com/Arceliar/ironwood'
%{__tar} --strip-components=1 -C 'vendor/github.com/Arceliar/ironwood' -xf %{SOURCE100}
echo '# github.com/Arceliar/ironwood v0.0.0-20210619124114-6ad55cae5031' >> vendor/modules.txt
echo '## explicit' >> vendor/modules.txt
find 'vendor/github.com/Arceliar/ironwood' -type f -name '*.go' -print | sed -e 's|^vendor/||' -e 's|/[^/]*\.go$||' | uniq >> vendor/modules.txt
# github.com/Arceliar/phony v0.0.0-20210209235338-dde1a8dca979
%{__mkdir_p} 'vendor/github.com/Arceliar/phony'
%{__tar} --strip-components=1 -C 'vendor/github.com/Arceliar/phony' -xf %{SOURCE101}
echo '# github.com/Arceliar/phony v0.0.0-20210209235338-dde1a8dca979' >> vendor/modules.txt
echo '## explicit' >> vendor/modules.txt
find 'vendor/github.com/Arceliar/phony' -type f -name '*.go' -print | sed -e 's|^vendor/||' -e 's|/[^/]*\.go$||' | uniq >> vendor/modules.txt
# github.com/VividCortex/ewma v1.2.0
%{__mkdir_p} 'vendor/github.com/VividCortex/ewma'
%{__tar} --strip-components=1 -C 'vendor/github.com/VividCortex/ewma' -xf %{SOURCE102}
echo '# github.com/VividCortex/ewma v1.2.0' >> vendor/modules.txt
echo '## explicit' >> vendor/modules.txt
find 'vendor/github.com/VividCortex/ewma' -type f -name '*.go' -print | sed -e 's|^vendor/||' -e 's|/[^/]*\.go$||' | uniq >> vendor/modules.txt
# github.com/cheggaaa/pb/v3 v3.0.8
%{__mkdir_p} 'vendor/github.com/cheggaaa/pb'
%{__tar} --strip-components=1 -C 'vendor/github.com/cheggaaa/pb' -xf %{SOURCE103}
echo '# github.com/cheggaaa/pb/v3 v3.0.8' >> vendor/modules.txt
echo '## explicit' >> vendor/modules.txt
find 'vendor/github.com/cheggaaa/pb/v3' -type f -name '*.go' -print | sed -e 's|^vendor/||' -e 's|/[^/]*\.go$||' | uniq >> vendor/modules.txt
# github.com/fatih/color v1.12.0
%{__mkdir_p} 'vendor/github.com/fatih/color'
%{__tar} --strip-components=1 -C 'vendor/github.com/fatih/color' -xf %{SOURCE104}
echo '# github.com/fatih/color v1.12.0' >> vendor/modules.txt
echo '## explicit' >> vendor/modules.txt
find 'vendor/github.com/fatih/color' -type f -name '*.go' -print | sed -e 's|^vendor/||' -e 's|/[^/]*\.go$||' | uniq >> vendor/modules.txt
# github.com/gologme/log v1.2.0
%{__mkdir_p} 'vendor/github.com/gologme/log'
%{__tar} --strip-components=1 -C 'vendor/github.com/gologme/log' -xf %{SOURCE105}
echo '# github.com/gologme/log v1.2.0' >> vendor/modules.txt
echo '## explicit' >> vendor/modules.txt
find 'vendor/github.com/gologme/log' -type f -name '*.go' -print | sed -e 's|^vendor/||' -e 's|/[^/]*\.go$||' | uniq >> vendor/modules.txt
# github.com/hashicorp/go-syslog v1.0.0
%{__mkdir_p} 'vendor/github.com/hashicorp/go-syslog'
%{__tar} --strip-components=1 -C 'vendor/github.com/hashicorp/go-syslog' -xf %{SOURCE106}
echo '# github.com/hashicorp/go-syslog v1.0.0' >> vendor/modules.txt
echo '## explicit' >> vendor/modules.txt
find 'vendor/github.com/hashicorp/go-syslog' -type f -name '*.go' -print | sed -e 's|^vendor/||' -e 's|/[^/]*\.go$||' | uniq >> vendor/modules.txt
# github.com/hjson/hjson-go v3.1.0+incompatible
%{__mkdir_p} 'vendor/github.com/hjson/hjson-go'
%{__tar} --strip-components=1 -C 'vendor/github.com/hjson/hjson-go' -xf %{SOURCE107}
echo '# github.com/hjson/hjson-go v3.1.0+incompatible' >> vendor/modules.txt
echo '## explicit' >> vendor/modules.txt
find 'vendor/github.com/hjson/hjson-go' -type f -name '*.go' -print | sed -e 's|^vendor/||' -e 's|/[^/]*\.go$||' | uniq >> vendor/modules.txt
# github.com/kardianos/minwinsvc v1.0.0
%{__mkdir_p} 'vendor/github.com/kardianos/minwinsvc'
%{__tar} --strip-components=1 -C 'vendor/github.com/kardianos/minwinsvc' -xf %{SOURCE108}
echo '# github.com/kardianos/minwinsvc v1.0.0' >> vendor/modules.txt
echo '## explicit' >> vendor/modules.txt
find 'vendor/github.com/kardianos/minwinsvc' -type f -name '*.go' -print | sed -e 's|^vendor/||' -e 's|/[^/]*\.go$||' | uniq >> vendor/modules.txt
# github.com/lxn/walk v0.0.0-20210112085537-c389da54e794
%{__mkdir_p} 'vendor/github.com/lxn/walk'
%{__tar} --strip-components=1 -C 'vendor/github.com/lxn/walk' -xf %{SOURCE109}
echo '# github.com/lxn/walk v0.0.0-20210112085537-c389da54e794' >> vendor/modules.txt
find 'vendor/github.com/lxn/walk' -type f -name '*.go' -print | sed -e 's|^vendor/||' -e 's|/[^/]*\.go$||' | uniq >> vendor/modules.txt
# github.com/lxn/win v0.0.0-20210218163916-a377121e959e
%{__mkdir_p} 'vendor/github.com/lxn/win'
%{__tar} --strip-components=1 -C 'vendor/github.com/lxn/win' -xf %{SOURCE110}
echo '# github.com/lxn/win v0.0.0-20210218163916-a377121e959e' >> vendor/modules.txt
find 'vendor/github.com/lxn/win' -type f -name '*.go' -print | sed -e 's|^vendor/||' -e 's|/[^/]*\.go$||' | uniq >> vendor/modules.txt
# github.com/mattn/go-colorable v0.1.8
%{__mkdir_p} 'vendor/github.com/mattn/go-colorable'
%{__tar} --strip-components=1 -C 'vendor/github.com/mattn/go-colorable' -xf %{SOURCE111}
echo '# github.com/mattn/go-colorable v0.1.8' >> vendor/modules.txt
find 'vendor/github.com/mattn/go-colorable' -type f -name '*.go' -print | sed -e 's|^vendor/||' -e 's|/[^/]*\.go$||' | uniq >> vendor/modules.txt
# github.com/mattn/go-isatty v0.0.13
%{__mkdir_p} 'vendor/github.com/mattn/go-isatty'
%{__tar} --strip-components=1 -C 'vendor/github.com/mattn/go-isatty' -xf %{SOURCE112}
echo '# github.com/mattn/go-isatty v0.0.13' >> vendor/modules.txt
echo '## explicit' >> vendor/modules.txt
find 'vendor/github.com/mattn/go-isatty' -type f -name '*.go' -print | sed -e 's|^vendor/||' -e 's|/[^/]*\.go$||' | uniq >> vendor/modules.txt
# github.com/mattn/go-runewidth v0.0.13
%{__mkdir_p} 'vendor/github.com/mattn/go-runewidth'
%{__tar} --strip-components=1 -C 'vendor/github.com/mattn/go-runewidth' -xf %{SOURCE113}
echo '# github.com/mattn/go-runewidth v0.0.13' >> vendor/modules.txt
echo '## explicit' >> vendor/modules.txt
find 'vendor/github.com/mattn/go-runewidth' -type f -name '*.go' -print | sed -e 's|^vendor/||' -e 's|/[^/]*\.go$||' | uniq >> vendor/modules.txt
# github.com/mitchellh/mapstructure v1.4.1
%{__mkdir_p} 'vendor/github.com/mitchellh/mapstructure'
%{__tar} --strip-components=1 -C 'vendor/github.com/mitchellh/mapstructure' -xf %{SOURCE114}
echo '# github.com/mitchellh/mapstructure v1.4.1' >> vendor/modules.txt
echo '## explicit' >> vendor/modules.txt
find 'vendor/github.com/mitchellh/mapstructure' -type f -name '*.go' -print | sed -e 's|^vendor/||' -e 's|/[^/]*\.go$||' | uniq >> vendor/modules.txt
# github.com/rivo/uniseg v0.2.0
%{__mkdir_p} 'vendor/github.com/rivo/uniseg'
%{__tar} --strip-components=1 -C 'vendor/github.com/rivo/uniseg' -xf %{SOURCE115}
echo '# github.com/rivo/uniseg v0.2.0' >> vendor/modules.txt
find 'vendor/github.com/rivo/uniseg' -type f -name '*.go' -print | sed -e 's|^vendor/||' -e 's|/[^/]*\.go$||' | uniq >> vendor/modules.txt
# github.com/vishvananda/netlink v1.1.0
%{__mkdir_p} 'vendor/github.com/vishvananda/netlink'
%{__tar} --strip-components=1 -C 'vendor/github.com/vishvananda/netlink' -xf %{SOURCE116}
echo '# github.com/vishvananda/netlink v1.1.0' >> vendor/modules.txt
echo '## explicit' >> vendor/modules.txt
find 'vendor/github.com/vishvananda/netlink' -type f -name '*.go' -print | sed -e 's|^vendor/||' -e 's|/[^/]*\.go$||' | uniq >> vendor/modules.txt
# github.com/vishvananda/netns v0.0.0-20210104183010-2eb08e3e575f
%{__mkdir_p} 'vendor/github.com/vishvananda/netns'
%{__tar} --strip-components=1 -C 'vendor/github.com/vishvananda/netns' -xf %{SOURCE117}
echo '# github.com/vishvananda/netns v0.0.0-20210104183010-2eb08e3e575f' >> vendor/modules.txt
echo '## explicit' >> vendor/modules.txt
find 'vendor/github.com/vishvananda/netns' -type f -name '*.go' -print | sed -e 's|^vendor/||' -e 's|/[^/]*\.go$||' | uniq >> vendor/modules.txt
# golang.org/x/crypto v0.0.0-20210513164829-c07d793c2f9a
%{__mkdir_p} 'vendor/golang.org/x/crypto'
%{__tar} --strip-components=1 -C 'vendor/golang.org/x/crypto' -xf %{SOURCE118}
echo '# golang.org/x/crypto v0.0.0-20210513164829-c07d793c2f9a' >> vendor/modules.txt
echo '## explicit' >> vendor/modules.txt
find 'vendor/golang.org/x/crypto' -type f -name '*.go' -print | sed -e 's|^vendor/||' -e 's|/[^/]*\.go$||' | uniq >> vendor/modules.txt
# golang.org/x/net v0.0.0-20210610132358-84b48f89b13b
%{__mkdir_p} 'vendor/golang.org/x/net'
%{__tar} --strip-components=1 -C 'vendor/golang.org/x/net' -xf %{SOURCE119}
echo '# golang.org/x/net v0.0.0-20210610132358-84b48f89b13b' >> vendor/modules.txt
echo '## explicit' >> vendor/modules.txt
find 'vendor/golang.org/x/net' -type f -name '*.go' -print | sed -e 's|^vendor/||' -e 's|/[^/]*\.go$||' | uniq >> vendor/modules.txt
# golang.org/x/sys v0.0.0-20210611083646-a4fc73990273
%{__mkdir_p} 'vendor/golang.org/x/sys'
%{__tar} --strip-components=1 -C 'vendor/golang.org/x/sys' -xf %{SOURCE120}
echo '# golang.org/x/sys v0.0.0-20210611083646-a4fc73990273' >> vendor/modules.txt
echo '## explicit' >> vendor/modules.txt
find 'vendor/golang.org/x/sys' -type f -name '*.go' -print | sed -e 's|^vendor/||' -e 's|/[^/]*\.go$||' | uniq >> vendor/modules.txt
# golang.org/x/term v0.0.0-20201126162022-7de9c90e9dd1
%{__mkdir_p} 'vendor/golang.org/x/term'
%{__tar} --strip-components=1 -C 'vendor/golang.org/x/term' -xf %{SOURCE121}
echo '# golang.org/x/term v0.0.0-20201126162022-7de9c90e9dd1' >> vendor/modules.txt
find 'vendor/golang.org/x/term' -type f -name '*.go' -print | sed -e 's|^vendor/||' -e 's|/[^/]*\.go$||' | uniq >> vendor/modules.txt
# golang.org/x/text v0.3.7-0.20210503195748-5c7c50ebbd4f
%{__mkdir_p} 'vendor/golang.org/x/text'
%{__tar} --strip-components=1 -C 'vendor/golang.org/x/text' -xf %{SOURCE122}
echo '# golang.org/x/text v0.3.7-0.20210503195748-5c7c50ebbd4f' >> vendor/modules.txt
echo '## explicit' >> vendor/modules.txt
find 'vendor/golang.org/x/text' -type f -name '*.go' -print | sed -e 's|^vendor/||' -e 's|/[^/]*\.go$||' | uniq >> vendor/modules.txt
# golang.org/x/tools v0.0.0-20180917221912-90fa682c2a6e
%{__mkdir_p} 'vendor/golang.org/x/tools'
%{__tar} --strip-components=1 -C 'vendor/golang.org/x/tools' -xf %{SOURCE123}
echo '# golang.org/x/tools v0.0.0-20180917221912-90fa682c2a6e' >> vendor/modules.txt
find 'vendor/golang.org/x/tools' -type f -name '*.go' -print | sed -e 's|^vendor/||' -e 's|/[^/]*\.go$||' | uniq >> vendor/modules.txt
# golang.zx2c4.com/wireguard v0.0.0-20210604143328-f9b48a961cd2
%{__mkdir_p} 'vendor/golang.zx2c4.com/wireguard'
%{__tar} --strip-components=1 -C 'vendor/golang.zx2c4.com/wireguard' -xf %{SOURCE124}
echo '# golang.zx2c4.com/wireguard v0.0.0-20210604143328-f9b48a961cd2' >> vendor/modules.txt
echo '## explicit' >> vendor/modules.txt
find 'vendor/golang.zx2c4.com/wireguard' -type f -name '*.go' -print | sed -e 's|^vendor/||' -e 's|/[^/]*\.go$||' | uniq >> vendor/modules.txt
# golang.zx2c4.com/wireguard/windows v0.3.14
%{__mkdir_p} 'vendor/golang.zx2c4.com/wireguard/windows'
%{__tar} --strip-components=1 -C 'vendor/golang.zx2c4.com/wireguard/windows' -xf %{SOURCE125}
echo '# golang.zx2c4.com/wireguard/windows v0.3.14' >> vendor/modules.txt
echo '## explicit' >> vendor/modules.txt
find 'vendor/golang.zx2c4.com/wireguard/windows' -type f -name '*.go' -print | sed -e 's|^vendor/||' -e 's|/[^/]*\.go$||' | uniq >> vendor/modules.txt
#GO_BUNDLED_PREP_END

%build
export PKGNAME="%{name}"
export PKGVER="%{version}"
#export GOPROXY="https://proxy.golang.org,direct"
./build -t -p -l "-linkmode=external"

%install
rm -rf %{buildroot}
install -m 0755 -D yggdrasil %{buildroot}/%{_bindir}/yggdrasil
install -m 0755 -D yggdrasilctl %{buildroot}/%{_bindir}/yggdrasilctl
install -m 0644 -D contrib/systemd/yggdrasil.service \
        %{buildroot}/%{_unitdir}/yggdrasil.service
install -m 0644 -D contrib/systemd/yggdrasil-default-config.service \
        %{buildroot}/%{_unitdir}/yggdrasil-default-config.service

%files
%{_bindir}/yggdrasil
%{_bindir}/yggdrasilctl
%{_unitdir}/*.service

%post
%systemd_post yggdrasil.service

%preun
%systemd_preun yggdrasil.service

%postun
%systemd_postun_with_restart yggdrasil.service
%changelog
* Wed Nov  3 2021 Oleg Girko <ol@infoserver.lv> - 0.4.2-1
- Update to 0.4.2
* Wed Nov  3 2021 Oleg Girko <ol@infoserver.lv> - 0.4.0-3
- Add patch to fix crash by packets sent to any address in 2ff::/16
* Wed Jul  7 2021 Oleg Girko <ol@infoserver.lv> - 0.4.0-2
- Fix permissions of systemd service files
* Mon Jul  5 2021 Oleg Girko <ol@infoserver.lv> - 0.4.0-1
- Initial import
